import requests, re

def capitalize_first_letter(name):
    # 最初の単語の先頭を大文字にし、残りはそのままにする
    return name[0].upper() + name[1:]


# 学名のリスト
#scientific_names = ["Homo sapiens", "Pan troglodytes", "Canis lupus"]
scientific_names = []
#with open("scientific_names.txt", "r") as f:
with open("020_test.txt", "r") as f:
    for line in f:
        #scname, jnameTMP = line.split("\t")
        scname = line.strip()
        #scname = re.sub("-", " ", scname)
        #print("scname", scname)
        scientific_names.append(scname)
#exit()

# 学名から一般名を取得
for name in scientific_names:
    print(f"Processing: {name}")
    try:
        # 学名からTaxIDを取得
        search_url = f"https://eutils.ncbi.nlm.nih.gov/entrez/eutils/esearch.fcgi?db=taxonomy&term={name}&retmode=json"
        search_response = requests.get(search_url).json()
        if search_response["esearchresult"]["idlist"]:
            taxid = search_response["esearchresult"]["idlist"][0]
    
            # TaxIDから一般名を取得
            summary_url = f"https://eutils.ncbi.nlm.nih.gov/entrez/eutils/esummary.fcgi?db=taxonomy&id={taxid}&retmode=json"
            summary_response = requests.get(summary_url).json()
            common_name = summary_response["result"][taxid]["commonname"]
            print("  common_name:", common_name)
    
            # 結果をファイルに書き込む
            with open("common_names.txt", "a") as f:
                if common_name:
                    common_name = capitalize_first_letter(common_name)  # 先頭を大文字にする
                    f.write(f"{name}\t{common_name}\n")
                else:
                    f.write(f"{name}\tNotFound\n")
        else:
            print(f"    No TaxID found for {name}")
            with open("common_names.txt", "a") as f:
                f.write(f"{name}\tNotFound\n")

    except requests.exceptions.JSONDecodeError:
        print(f"Failed to decode JSON response for {name}")
        with open("common_names.txt", "a") as f:
            f.write(f"{name}\tFailed to decode JSON response\n")

# 結果を表示
#with open("common_names.txt", "r") as f:
#    print(f.read())