#!/bin/bash

# 学名のリストをファイルに保存
#echo -e "Homo sapiens\nPan troglodytes\nCanis lupus" > scientific_names.txt

# 出力ファイルを初期化
> common_names.txt

# 学名から一般名を取得
while IFS= read -r name; do
    echo "Processing: $name"  # デバッグ情報を出力
    taxid=$(esearch -db taxonomy -query "$name" | efetch -format docsum | xtract -pattern DocumentSummary -element TaxId)
    common_name=$(esummary -db taxonomy -id $taxid | xtract -pattern DocumentSummary -element CommonName)
    echo -e "$name\t$common_name" >> common_names.txt
done < scientific_names.txt

# 結果を表示
cat common_names.txt