#!/bin/bash

# 学名のリストをファイルに保存
#echo -e "Homo sapiens\nPan troglodytes\nCanis lupus" > scientific_names.txt

# 学名から一般名を取得
while read -r name; do
    taxid=$(esearch -db taxonomy -query "$name" | efetch -format docsum | xtract -pattern DocumentSummary -element TaxId)
    common_name=$(esummary -db taxonomy -id $taxid | xtract -pattern DocumentSummary -element CommonName)
    echo -e "$name\t$common_name"
done < scientific_names.txt > common_names.txt

# 結果を表示
cat common_names.txt
